package com.chinaitop.agile.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.agile.model.DataKcglFcbgzDefault;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample;

public interface DataKcglFcbgzDefaultService {

	/**
	 * 按照仓号、货位号、品种、粮食性质、日期为条件查询某一天最后录入的那条数据
	 * 
	 * @param fcbgz
	 * @return
	 * @throws Exception
	 */
	DataKcglFcbgzDefault findConditionMax(DataKcglFcbgzDefault fcbgz) throws Exception;

	/**
	 * 查询分仓保管账列表
	 * 
	 * @param example
	 * @return
	 * @throws Exception
	 */
	List<DataKcglFcbgzDefault> findByList(DataKcglFcbgzDefaultExample example) throws Exception;
	List<Map<String, Object>> findByListNew(Map<String, Object> param_map) throws Exception;

	/**
	 * 查询一条分仓保管账数据
	 * 
	 * @param id
	 * @return
	 */
	DataKcglFcbgzDefault findByIdFcbgzData(String id);

	/**
	 * 查询一条出入库数据的化验信息
	 * 
	 * @param id 分仓保管账表id
	 * @return
	 */
	Map<String, Object> queryCrkJyxx(String id);

	/**
	 * 查询出入库入库追溯列表
	 * 
	 * @param param_map
	 * @return
	 */
	List<Map<String, Object>> queryRkZsList(Map<String, Object> param_map);
}
