package com.chinaitop.agile.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.agile.model.Bgmxz;
import com.chinaitop.agile.model.DataKcglFcbgzDefault;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample;

public interface KeepAccountService {

	/**
	 * 根据条件查询保管账列表
	 * 
	 * @param example
	 * @return
	 */
	List<DataKcglFcbgzDefault> queryByExample(DataKcglFcbgzDefaultExample example);

	List<DataKcglFcbgzDefault> queryTotalByExample(DataKcglFcbgzDefaultExample example);

	/**
	 * 保管明细账
	 * 
	 * @param map
	 * @return
	 */
	List<DataKcglFcbgzDefault> selectHouseKeepAccountData(Map<String, Object> map);

	/**
	 * 根据保管账编号获取保管账信息
	 * 
	 * @param dataid
	 * @return
	 */
	DataKcglFcbgzDefault findById(String dataid);

	/**
	 * 查询保管明细账（新）
	 * @param map
	 * @return
	 */
	List<Bgmxz> selectBgmxz(Map<String, Object> map) throws Exception;

	/**
	 * 分仓保管账列表数据查询
	 * @param pageNum
	 * @param pageSize
	 * @param ch
	 * @param hwh
	 * @param lspz
	 * @param lsxz
	 * @param startDate
	 * @param endDate
	 * @param wjh
	 * @param zy
	 * @param orgId
	 * @return
	 * @throws Exception
	 */
	List<DataKcglFcbgzDefault> houseKeepAccountList(Integer pageNum, Integer pageSize,
													Integer ch, Integer hwh, Integer lspz, Integer lsxz,
													String startDate, String endDate,
													String wjh, String zy, String orgId) throws Exception;
}
