package com.chinaitop.agile.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import com.chinaitop.agile.mapper.CrkRecordMapper;
import com.chinaitop.agile.mapper.DataKcglXckcDefaultMapper;
import com.chinaitop.agile.model.DataKcglXckcDefault;
import com.chinaitop.agile.model.DataKcglXckcDefaultExample;
import com.chinaitop.agile.service.CrkRecordService;

@Service
public class CrkRecordServiceImpl implements CrkRecordService {

	@Resource
	private DataKcglXckcDefaultMapper dataKcglXckcDefaultdMapper;

	@Resource
	private CrkRecordMapper crkRecordMapper;

	public List<DataKcglXckcDefault> queryByExample(DataKcglXckcDefaultExample example) {
		return dataKcglXckcDefaultdMapper.selectByExample(example);
	}

	@Override
	public List<Map<String, Object>> queryQcCrkrecord(String cazylx, String pz, String beginDate, String endDate, 
			String houseId,String warehouseId, Integer orgId, String kqbm, String housename, 
            String mxpz, String cphm, String lsxz, String scnf) throws Exception {
		Map<String, Object> map = new HashMap<String, Object>();
        if (null != cazylx && !"".equals(cazylx)) {
            if (cazylx.equals("1")) {
                map.put("ywlx", "入仓");
            } else if (cazylx.equals("3")) {
                map.put("ywlx", "出仓");
            }
        }
        if (null != pz && !"".equals(pz)) {
            map.put("lspz", pz);
        }
        if (null != mxpz && !"".equals(mxpz)) {
            map.put("mxpz", mxpz);
        }
        if (beginDate != null && !"".equals(beginDate)) {
            map.put("startTime", beginDate+" 00:00:00");
        }
        if (endDate != null && !"".equals(endDate)) {
            map.put("endTime", endDate+" 23:59:59");
        }
        if (houseId != null && !"".equals(houseId)) {
            map.put("houseId", houseId);
        }
        if (null != housename && !"".equals(housename)) {
            map.put("housename", housename);
        }
        if (warehouseId != null && !"".equals(warehouseId)) {
            map.put("wareId", warehouseId);
        }
        if (orgId != null && !"".equals(orgId)) {
            map.put("orgId", orgId);
        }
        if (null != kqbm && !"".equals(kqbm)) {
            map.put("kqbm", kqbm);
        }
        if (null != cphm && !"".equals(cphm)) {
            map.put("cphm", cphm);
        }
        if (null != lsxz && !"".equals(lsxz)) {
            map.put("lsxz", lsxz);
        }
        if (null != scnf && !"".equals(scnf)) {
            map.put("scnf", scnf);
        }
		return crkRecordMapper.queryQcCrkrecord(map);
	}

	@Override
	public List<Map<String, Object>> queryAgentQcCrkrecord(Map<String, Object> map) {
		return crkRecordMapper.queryAgentQcCrkrecord(map);
	}

	@Override
	public List<Map<String, Object>> queryHcCrkrecord(Map<String, Object> map) {
		return crkRecordMapper.queryHcCrkrecord(map);
	}

	@Override
	public List<Map<String, Object>> queryAgentHcCrkrecord(Map<String, Object> map) {
		return crkRecordMapper.queryAgentHcCrkrecord(map);
	}

	@Override
	public List<Map<String, Object>> queryJyxx(Map<String, Object> map) {
		return crkRecordMapper.queryJyxx(map);
	}
	
	@Override
	public List<Map<String, Object>> queryJyxxNew(Map<String, Object> map) {
		return crkRecordMapper.queryJyxxNew(map);
	}

	@Override
	public List<Map<String, Object>> queryCzxx(Map<String, Object> map) {
		List<Map<String,Object>> czxx = null;
		if ("入仓".equals(map.get("ywlx"))) {
			czxx = crkRecordMapper.queryRkCzxx(map);
		} else {
			czxx = crkRecordMapper.queryCkCzxx(map);
		}
		return czxx;
	}

	/**
	 * 出入库监管统计查询列表
	 * @param map
	 * @return
	 */
	@Override
	public List<Map<String, Object>> queryCycleFoodCount(Map<String, Object> map) {
		return crkRecordMapper.queryCycleFoodCount(map);
	}

	/**
	 * 查询火车出入库质检信息
	 * @param conditionMap
	 * @return
	 */
	@Override
	public Map<String, Object> queryTrainJyxx(Map<String, Object> conditionMap) {
		return crkRecordMapper.queryTrainJyxx(conditionMap);
	}

	/**
	 * 查询火车出入库称重信息
	 *
	 * @param conditionMap 查询条件
	 * @return
	 */
	@Override
	public Map<String, Object> queryTrainCzxx(Map<String, Object> conditionMap) {
		return crkRecordMapper.queryTrainCzxx(conditionMap);
	}

	@Override
	public List<Map<String, Object>> queryRkData(Map<String, Object> map) {
		return crkRecordMapper.queryRkData(map);
	}

	@Override
	public List<Map<String, Object>> queryCkData(Map<String, Object> map) {
		return crkRecordMapper.queryCkData(map);
	}

	@Override
	public String queryDataLspz(Map<String, Object> conditionMap) {
		Map<String, Object> map = crkRecordMapper.queryDataLspz(conditionMap);
		return ObjectUtils.toString(map.get("enumId"), "");
	}
}
