package com.chinaitop.agile.service.impl;

import com.chinaitop.agile.feignService.KeepaccountFeignService;
import com.chinaitop.agile.mapper.BgmxzMapper;
import com.chinaitop.agile.mapper.DataKcglFcbgzDefaultMapper;
import com.chinaitop.agile.model.Bgmxz;
import com.chinaitop.agile.model.DataKcglFcbgzDefault;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample;
import com.chinaitop.agile.service.DataKcglFcbgzDefaultService;
import com.chinaitop.agile.service.KeepAccountService;
import com.chinaitop.utils.ParameterUtil;
import com.github.pagehelper.PageHelper;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class KeepAccountServiceImpl implements KeepAccountService {

	@Resource
	private DataKcglFcbgzDefaultMapper dataKcglFcbgzDefaultMapper;
	@Resource
	private BgmxzMapper bgmxzMapper;
	@Resource
	private DataKcglFcbgzDefaultService fcbgzService;
	@Resource
	private KeepaccountFeignService keepaccountFeignService;

	public List<DataKcglFcbgzDefault> queryByExample(DataKcglFcbgzDefaultExample example) {
		return dataKcglFcbgzDefaultMapper.selectByExample(example);
	}

	public DataKcglFcbgzDefault findById(String dataid) {
		return dataKcglFcbgzDefaultMapper.selectByPrimaryKey(dataid);
	}

	@Override
	public List<Bgmxz> selectBgmxz(Map<String, Object> map) throws Exception {
		List<Bgmxz> list = bgmxzMapper.selectbgmxz(map);

		return list;
	}

	@Override
	public List<DataKcglFcbgzDefault> houseKeepAccountList(Integer pageNum, Integer pageSize, Integer ch, Integer hwh, Integer lspz, Integer lsxz, String startDate, String endDate, String wjh, String zy, String orgId) throws Exception {

		DataKcglFcbgzDefaultExample example = new DataKcglFcbgzDefaultExample();
		DataKcglFcbgzDefaultExample.Criteria criteria = example.createCriteria();
		//( srsl > ? and pz = ? and hwxz = ? ) or( zcsl > ? and pz = ? and hwxz = ? )
		DataKcglFcbgzDefaultExample.Criteria criteria1 = example.createCriteria();
		criteria.andSrslGreaterThan(0.0);
		criteria.andDirectionEqualTo(1);
		if (null != orgId) {
			criteria.andUnitidEqualTo(orgId);
		}
		criteria1.andZcslGreaterThan(0.0);
		criteria1.andDirectionEqualTo(1);

		if (ch!=null) {
			criteria.andChEqualTo(ch);
			criteria1.andChEqualTo(ch);
		}
		if (hwh!=null) {
			criteria.andHwhEqualTo(hwh);
			criteria1.andHwhEqualTo(hwh);
		}
		if (lspz != null) {
			criteria.andPzEqualTo(lspz+"");
			criteria1.andPzEqualTo(lspz+"");
		}
		if (lsxz != null) {
			criteria.andHwxzEqualTo(lsxz+"");
			criteria1.andHwxzEqualTo(lsxz+"");
		}
		if (startDate != null && !"".equals(startDate)) {
			Date start_rq = ParameterUtil.string2datetime(startDate+" 00:00:00");
			criteria.andRqGreaterThanOrEqualTo(start_rq);
			criteria1.andRqGreaterThanOrEqualTo(start_rq);
		}
		if (endDate != null && !"".equals(endDate)) {
			Date end_rq = ParameterUtil.string2datetime(endDate+" 23:59:59");
			criteria.andRqLessThanOrEqualTo(end_rq);
			criteria1.andRqLessThanOrEqualTo(end_rq);
		}
		if (wjh != null && !"".equals(wjh)) {
			criteria.andWjhEqualTo(wjh);
			criteria1.andWjhEqualTo(wjh);
		}
		if (zy != null && !"".equals(zy)) {
			criteria.andZyEqualTo(zy);
			criteria1.andZyEqualTo(zy);
		}
		if (null != orgId) {
			criteria1.andUnitidEqualTo(orgId);
		}
		example.or(criteria1);
		if (pageNum!=null && pageSize!=null) {
			PageHelper.startPage(pageNum, pageSize);
		}
		example.setOrderByClause("ModifyDate desc");
		List<DataKcglFcbgzDefault> list = dataKcglFcbgzDefaultMapper.countByDay(example);
		if (null != list && list.size() > 0) {
			list = getFcbgzJzsj(list);
		}

		return list;
	}

	public List<DataKcglFcbgzDefault> queryTotalByExample(DataKcglFcbgzDefaultExample example) {
		return dataKcglFcbgzDefaultMapper.countByDay(example);
	}

	public List<DataKcglFcbgzDefault> selectHouseKeepAccountData(Map<String, Object> map) {
		return dataKcglFcbgzDefaultMapper.selectHouseKeepAccountData(map);
	}

	public List<DataKcglFcbgzDefault> getFcbgzJzsj(List<DataKcglFcbgzDefault> list) throws Exception {

		for (DataKcglFcbgzDefault fcbgz : list) {
			DataKcglFcbgzDefault obj = fcbgzService.findConditionMax(fcbgz);
			fcbgz.setKcsl(obj.getKcsl());
			Map<String, Object> map = keepaccountFeignService.selectHouseKeepAccountData(fcbgz.getCh(),
					fcbgz.getHwh(),
					Integer.parseInt(fcbgz.getHwxz()),
					Integer.parseInt(fcbgz.getPz()),
					ParameterUtil.date2string(fcbgz.getRqs()),
					fcbgz.getWjh(),
					fcbgz.getZy(),
					0,
					Integer.parseInt(fcbgz.getUnitid()));
			Map<String, Object> datamap = (Map<String, Object>) map.get("obj");
			fcbgz.setAccountingPerson(ObjectUtils.toString(datamap.get("accountingPerson"),""));
			fcbgz.setAuditor(ObjectUtils.toString(datamap.get("auditor"),""));
			if(datamap.get("sssh")!=null){
				fcbgz.setSssh((Double)datamap.get("sssh"));
			}
			if(datamap.get("zbszsl")!=null){
				fcbgz.setZbszsl((Double)datamap.get("zbszsl"));
			}
		}

		return list;
	}

}
