package com.chinaitop.agile.service.impl;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import com.chinaitop.agile.utils.ParameterUtil;
import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.springframework.stereotype.Service;

import com.chinaitop.agile.mapper.DataKcglKcswDefaultMapper;
import com.chinaitop.agile.service.RegistrationService;

@Service
public class RegistrationServiceImpl implements RegistrationService{

	@Resource
	private DataKcglKcswDefaultMapper dataKcglKcswDefaultMapper;

	@Override
	public List<Map<String, Object>> getWheatListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getWheatList(map);
	}

	@Override
	public List<Map<String, Object>> getCornListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getCornList(map);
	}

	@Override
	public List<Map<String, Object>> getSoybeanListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getSoybeanList(map);
	}

	@Override
	public List<Map<String, Object>> getRiceListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getRiceList(map);
	}
	
	@Override
	public List<Map<String, Object>> getCrudeOilListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getCrudeOilList(map);
	}

	@Override
	public HSSFWorkbook wheatdataTransfor(List<Map<String, Object>> list, String zbr, String shdw, String dwfzr) {
		HSSFWorkbook wb = new HSSFWorkbook();
		String name = "小麦";
		HSSFSheet sheet = wb.createSheet(name);
		// 起始行、结束行、起始列、结束列
		CellRangeAddress rangeAddress = new CellRangeAddress(0,0,0,16);
		CellRangeAddress rangeAddress1 = new CellRangeAddress(2,4,1,1);
		CellRangeAddress rangeAddress2 = new CellRangeAddress(2,4,2,2);
		CellRangeAddress rangeAddress3 = new CellRangeAddress(2,4,3,3);
		CellRangeAddress rangeAddress4 = new CellRangeAddress(2,4,4,4);
		CellRangeAddress rangeAddress5 = new CellRangeAddress(2,4,5,5);
		CellRangeAddress rangeAddress6 = new CellRangeAddress(2,4,6,6);
		CellRangeAddress rangeAddress7 = new CellRangeAddress(2,2,7,13);
		CellRangeAddress rangeAddress8 = new CellRangeAddress(2,4,14,14);
		CellRangeAddress rangeAddress9 = new CellRangeAddress(2,4,15,15);
		CellRangeAddress rangeAddress10 = new CellRangeAddress(2,4,16,16);
		CellRangeAddress rangeAddress11 = new CellRangeAddress(3,4,7,7);
		CellRangeAddress rangeAddress12 = new CellRangeAddress(3,4,8,8);
		CellRangeAddress rangeAddress13 = new CellRangeAddress(3,4,9,9);
		CellRangeAddress rangeAddress14 = new CellRangeAddress(3,3,10,11);
		CellRangeAddress rangeAddress15 = new CellRangeAddress(1,1,0,5);
		CellRangeAddress rangeAddress16 = new CellRangeAddress(1,1,6,12);
		CellRangeAddress rangeAddress17 = new CellRangeAddress(3,3,10,11);
		CellRangeAddress rangeAddress18 = new CellRangeAddress(2,4,0,0);
		CellRangeAddress rangeAddress22 = new CellRangeAddress(1,1,13,16);
		CellRangeAddress rangeAddress23 = new CellRangeAddress(3,4,12,12);
		CellRangeAddress rangeAddress24 = new CellRangeAddress(3,4,13,13);

		sheet.addMergedRegion(rangeAddress);
		sheet.addMergedRegion(rangeAddress1);
		sheet.addMergedRegion(rangeAddress2);
		sheet.addMergedRegion(rangeAddress3);
		sheet.addMergedRegion(rangeAddress4);
		sheet.addMergedRegion(rangeAddress5);
		sheet.addMergedRegion(rangeAddress6);
		sheet.addMergedRegion(rangeAddress7);
		sheet.addMergedRegion(rangeAddress8);
		sheet.addMergedRegion(rangeAddress9);
		sheet.addMergedRegion(rangeAddress10);
		sheet.addMergedRegion(rangeAddress11);
		sheet.addMergedRegion(rangeAddress12);
		sheet.addMergedRegion(rangeAddress13);
		sheet.addMergedRegion(rangeAddress14);
		sheet.addMergedRegion(rangeAddress15);
		sheet.addMergedRegion(rangeAddress16);
		sheet.addMergedRegion(rangeAddress17);
		sheet.addMergedRegion(rangeAddress18);
		sheet.addMergedRegion(rangeAddress22);
		sheet.addMergedRegion(rangeAddress23);
		sheet.addMergedRegion(rangeAddress24);

		HSSFCellStyle headStyle = wb.createCellStyle();
		HSSFFont headFont = wb.createFont();
		headFont.setFontName("黑体");
		headFont.setFontHeightInPoints((short) 18);
		headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		headStyle.setFont(headFont);
		headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

		HSSFCellStyle titleStyle = wb.createCellStyle();
		HSSFFont titleFont = wb.createFont();
		titleFont.setFontName("黑体");
		titleFont.setFontHeightInPoints((short) 12);
		titleStyle.setFont(titleFont);

		HSSFCellStyle contentStyle = wb.createCellStyle();
		HSSFFont contentFont = wb.createFont();
		contentFont.setFontName("黑体");
		contentFont.setFontHeightInPoints((short) 12);
		contentStyle.setFont(contentFont);
		contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
		contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
		contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
		contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
		contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

		HSSFRow sheetRow = sheet.createRow(0);
		HSSFCell cell = sheetRow.createCell(0);
		cell.setCellValue("天津市粮食储备有限公司市级储备小麦轮换入库情况登统表");
		cell.setCellStyle(headStyle);

		HSSFRow sheetRow1 = sheet.createRow(1);
		HSSFCell cell1 = sheetRow1.createCell(0);
		HSSFCell cell2 = sheetRow1.createCell(6);
		HSSFCell cell3 = sheetRow1.createCell(13);
		cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
		cell1.setCellStyle(titleStyle);
		SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
		cell2.setCellValue("填报日期："+format.format(new Date()));
		cell2.setCellStyle(titleStyle);
		cell3.setCellValue("计量单位：吨（保留小数）");
		cell3.setCellStyle(titleStyle);

		//在表格的第一行设置与数据库列名对应的列的名称
		int rowNum = 2;
		HSSFRow row = sheet.createRow(rowNum);
		HSSFCell rowCell1 = row.createCell(0);
		HSSFCell rowCell2 = row.createCell(1);
		HSSFCell rowCell3 = row.createCell(2);
		HSSFCell rowCell4 = row.createCell(3);
		HSSFCell rowCell5 = row.createCell(4);
		HSSFCell rowCell6 = row.createCell(5);
		HSSFCell rowCell7 = row.createCell(6);
		HSSFCell rowCell8 = row.createCell(7);
		HSSFCell rowCell9 = row.createCell(8);
		HSSFCell rowCell10 = row.createCell(9);
		HSSFCell rowCell11 = row.createCell(10);
		HSSFCell rowCell12 = row.createCell(11);
		HSSFCell rowCell13 = row.createCell(12);
		HSSFCell rowCell14 = row.createCell(13);
		HSSFCell rowCell15 = row.createCell(14);
		HSSFCell rowCell16 = row.createCell(15);
		HSSFCell rowCell17 = row.createCell(16);

		rowCell1.setCellValue("序号");
		rowCell2.setCellValue("车号");
		rowCell3.setCellValue("仓号");
		rowCell4.setCellValue("品名");
		rowCell5.setCellValue("生产年度");
		rowCell6.setCellValue("入库日期");
		rowCell7.setCellValue("入库数量");
		rowCell8.setCellValue("入库质量指标");
		rowCell15.setCellValue("硬度指数H1");
		rowCell16.setCellValue("存储方式");
		rowCell17.setCellValue("备注");
		rowCell1.setCellStyle(contentStyle);
		rowCell2.setCellStyle(contentStyle);
		rowCell3.setCellStyle(contentStyle);
		rowCell4.setCellStyle(contentStyle);
		rowCell5.setCellStyle(contentStyle);
		rowCell6.setCellStyle(contentStyle);
		rowCell7.setCellStyle(contentStyle);
		rowCell8.setCellStyle(contentStyle);
		rowCell9.setCellStyle(contentStyle);
		rowCell10.setCellStyle(contentStyle);
		rowCell11.setCellStyle(contentStyle);
		rowCell12.setCellStyle(contentStyle);
		rowCell13.setCellStyle(contentStyle);
		rowCell14.setCellStyle(contentStyle);
		rowCell15.setCellStyle(contentStyle);
		rowCell16.setCellStyle(contentStyle);
		rowCell17.setCellStyle(contentStyle);

		rowNum+=1;
		HSSFRow row1 = sheet.createRow(rowNum);
		HSSFCell row1Cell1 = row1.createCell(0);
		HSSFCell row1Cell2 = row1.createCell(1);
		HSSFCell row1Cell3 = row1.createCell(2);
		HSSFCell row1Cell4 = row1.createCell(3);
		HSSFCell row1Cell5 = row1.createCell(4);
		HSSFCell row1Cell6 = row1.createCell(5);
		HSSFCell row1Cell7 = row1.createCell(6);
		HSSFCell row1Cell8 = row1.createCell(7);
		HSSFCell row1Cell9 = row1.createCell(8);
		HSSFCell row1Cell10 = row1.createCell(9);
		HSSFCell row1Cell11 = row1.createCell(10);
		HSSFCell row1Cell12 = row1.createCell(11);
		HSSFCell row1Cell13 = row1.createCell(12);
		HSSFCell row1Cell14 = row1.createCell(13);
		HSSFCell row1Cell15 = row1.createCell(14);
		HSSFCell row1Cell16 = row1.createCell(15);
		HSSFCell row1Cell17 = row1.createCell(16);
		row1Cell8.setCellValue("等级");
		row1Cell9.setCellValue("容重g/L");
		row1Cell10.setCellValue("不完善粒%");
		row1Cell11.setCellValue("杂质%");
		row1Cell13.setCellValue("水分%");
		row1Cell14.setCellValue("色泽气味");
		row1Cell1.setCellStyle(contentStyle);
		row1Cell2.setCellStyle(contentStyle);
		row1Cell3.setCellStyle(contentStyle);
		row1Cell4.setCellStyle(contentStyle);
		row1Cell5.setCellStyle(contentStyle);
		row1Cell6.setCellStyle(contentStyle);
		row1Cell7.setCellStyle(contentStyle);
		row1Cell8.setCellStyle(contentStyle);
		row1Cell9.setCellStyle(contentStyle);
		row1Cell10.setCellStyle(contentStyle);
		row1Cell11.setCellStyle(contentStyle);
		row1Cell12.setCellStyle(contentStyle);
		row1Cell13.setCellStyle(contentStyle);
		row1Cell14.setCellStyle(contentStyle);
		row1Cell15.setCellStyle(contentStyle);
		row1Cell16.setCellStyle(contentStyle);
		row1Cell17.setCellStyle(contentStyle);

		rowNum+=1;
		HSSFRow row2 = sheet.createRow(rowNum);
		HSSFCell row2Cell1 = row2.createCell(0);
		HSSFCell row2Cell2 = row2.createCell(1);
		HSSFCell row2Cell3 = row2.createCell(2);
		HSSFCell row2Cell4 = row2.createCell(3);
		HSSFCell row2Cell5 = row2.createCell(4);
		HSSFCell row2Cell6 = row2.createCell(5);
		HSSFCell row2Cell7 = row2.createCell(6);
		HSSFCell row2Cell8 = row2.createCell(7);
		HSSFCell row2Cell9 = row2.createCell(8);
		HSSFCell row2Cell10 = row2.createCell(9);
		HSSFCell row2Cell11 = row2.createCell(10);
		HSSFCell row2Cell12 = row2.createCell(11);
		HSSFCell row2Cell13 = row2.createCell(12);
		HSSFCell row2Cell14 = row2.createCell(13);
		HSSFCell row2Cell15 = row2.createCell(14);
		HSSFCell row2Cell16 = row2.createCell(15);
		HSSFCell row2Cell17 = row2.createCell(16);
		row2Cell11.setCellValue("总量");
		row2Cell12.setCellValue("矿物质");
		row2Cell1.setCellStyle(contentStyle);
		row2Cell2.setCellStyle(contentStyle);
		row2Cell3.setCellStyle(contentStyle);
		row2Cell4.setCellStyle(contentStyle);
		row2Cell5.setCellStyle(contentStyle);
		row2Cell6.setCellStyle(contentStyle);
		row2Cell7.setCellStyle(contentStyle);
		row2Cell8.setCellStyle(contentStyle);
		row2Cell9.setCellStyle(contentStyle);
		row2Cell10.setCellStyle(contentStyle);
		row2Cell11.setCellStyle(contentStyle);
		row2Cell12.setCellStyle(contentStyle);
		row2Cell13.setCellStyle(contentStyle);
		row2Cell14.setCellStyle(contentStyle);
		row2Cell15.setCellStyle(contentStyle);
		row2Cell16.setCellStyle(contentStyle);
		row2Cell17.setCellStyle(contentStyle);


		Integer xh=1;
		double rksl = 0d;
		for(int i=0; i<list.size();i++){
			HSSFRow hssfRow = sheet.createRow(++rowNum);
			HSSFCell hssfCell1 = hssfRow.createCell(0);
			HSSFCell hssfCell2 = hssfRow.createCell(1);
			HSSFCell hssfCell3 = hssfRow.createCell(2);
			HSSFCell hssfCell4 = hssfRow.createCell(3);
			HSSFCell hssfCell5 = hssfRow.createCell(4);
			HSSFCell hssfCell6 = hssfRow.createCell(5);
			HSSFCell hssfCell7 = hssfRow.createCell(6);
			HSSFCell hssfCell8 = hssfRow.createCell(7);
			HSSFCell hssfCell9 = hssfRow.createCell(8);
			HSSFCell hssfCell10 = hssfRow.createCell(9);
			HSSFCell hssfCell11 = hssfRow.createCell(10);
			HSSFCell hssfCell12 = hssfRow.createCell(11);
			HSSFCell hssfCell13 = hssfRow.createCell(12);
			HSSFCell hssfCell14 = hssfRow.createCell(13);
			HSSFCell hssfCell15 = hssfRow.createCell(14);
			HSSFCell hssfCell16 = hssfRow.createCell(15);
			HSSFCell hssfCell17 = hssfRow.createCell(16);
			hssfCell1.setCellValue(xh);
			hssfCell2.setCellValue((String)list.get(i).get("cphm"));
			hssfCell3.setCellValue((String)list.get(i).get("cf"));
			hssfCell4.setCellValue((String)list.get(i).get("lspz"));
			hssfCell5.setCellValue((String)list.get(i).get("scnf"));
			Date date = (Date)list.get(i).get("rq");
			hssfCell6.setCellValue(format.format(date));
			rksl = Double.parseDouble(list.get(i).get("rksl").toString());
			rksl = rksl/1000;
			String rksls = rksl+"";
			rksls = ParameterUtil.decimalFormat(3, rksls, true);
			hssfCell7.setCellValue(rksls);
			//hssfCell7.setCellValue(((BigDecimal)list.get(i).get("rksl")).toString());
			hssfCell8.setCellValue((String)list.get(i).get("lsdj"));
			hssfCell9.setCellValue((String)list.get(i).get("rz"));
			hssfCell10.setCellValue((String)list.get(i).get("bwslzl"));
			hssfCell11.setCellValue((String)list.get(i).get("zzzl"));
			hssfCell12.setCellValue((String)list.get(i).get("kwz"));
			hssfCell13.setCellValue((String)list.get(i).get("sf"));
			hssfCell14.setCellValue((String)list.get(i).get("szqw"));
			hssfCell15.setCellValue((String)list.get(i).get("ydzs"));
			hssfCell16.setCellValue((String)list.get(i).get("ccfs"));
			hssfCell1.setCellStyle(contentStyle);
			hssfCell2.setCellStyle(contentStyle);
			hssfCell3.setCellStyle(contentStyle);
			hssfCell4.setCellStyle(contentStyle);
			hssfCell5.setCellStyle(contentStyle);
			hssfCell6.setCellStyle(contentStyle);
			hssfCell7.setCellStyle(contentStyle);
			hssfCell8.setCellStyle(contentStyle);
			hssfCell9.setCellStyle(contentStyle);
			hssfCell10.setCellStyle(contentStyle);
			hssfCell11.setCellStyle(contentStyle);
			hssfCell12.setCellStyle(contentStyle);
			hssfCell13.setCellStyle(contentStyle);
			hssfCell14.setCellStyle(contentStyle);
			hssfCell15.setCellStyle(contentStyle);
			hssfCell16.setCellStyle(contentStyle);
			hssfCell17.setCellStyle(contentStyle);
			++xh;
		}
		HSSFRow hssfRow = sheet.createRow(rowNum+1);
		hssfRow.createCell(0).setCellValue("单位负责人：" + (dwfzr==null?"":dwfzr));
		hssfRow.createCell(6).setCellValue("科长：");
		hssfRow.createCell(13).setCellValue("制表人："+ (zbr==null?"":zbr));
		CellRangeAddress rangeAddress19 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);
		CellRangeAddress rangeAddress20 = new CellRangeAddress(rowNum+1,rowNum+1,6,12);
		CellRangeAddress rangeAddress21 = new CellRangeAddress(rowNum+1,rowNum+1,13,16);
		sheet.addMergedRegion(rangeAddress19);
		sheet.addMergedRegion(rangeAddress20);
		sheet.addMergedRegion(rangeAddress21);
		return wb;
	}

	@Override
	public HSSFWorkbook ricedataTransfor(List<Map<String, Object>> list, String zbr, String shdw, String dwfzr) {
		HSSFWorkbook wb = new HSSFWorkbook();
		String name = "稻谷";
		HSSFSheet sheet = wb.createSheet(name);
		// 起始行、结束行、起始列、结束列
		CellRangeAddress rangeAddress = new CellRangeAddress(0,0,0,18);
		CellRangeAddress rangeAddress1 = new CellRangeAddress(2,3,1,1);
		CellRangeAddress rangeAddress2 = new CellRangeAddress(2,3,2,2);
		CellRangeAddress rangeAddress3 = new CellRangeAddress(2,3,3,3);
		CellRangeAddress rangeAddress4 = new CellRangeAddress(2,3,4,4);
		CellRangeAddress rangeAddress5 = new CellRangeAddress(2,3,5,5);
		CellRangeAddress rangeAddress6 = new CellRangeAddress(2,3,6,6);
		CellRangeAddress rangeAddress7 = new CellRangeAddress(2,2,7,16);
		CellRangeAddress rangeAddress8 = new CellRangeAddress(2,3,17,17);
		CellRangeAddress rangeAddress9 = new CellRangeAddress(2,3,18,18);
		CellRangeAddress rangeAddress15 = new CellRangeAddress(1,1,0,5);
		CellRangeAddress rangeAddress16 = new CellRangeAddress(1,1,6,12);
		CellRangeAddress rangeAddress18 = new CellRangeAddress(2,3,0,0);
		CellRangeAddress rangeAddress22 = new CellRangeAddress(1,1,13,18);
		sheet.addMergedRegion(rangeAddress);
		sheet.addMergedRegion(rangeAddress1);
		sheet.addMergedRegion(rangeAddress2);
		sheet.addMergedRegion(rangeAddress3);
		sheet.addMergedRegion(rangeAddress4);
		sheet.addMergedRegion(rangeAddress5);
		sheet.addMergedRegion(rangeAddress6);
		sheet.addMergedRegion(rangeAddress7);
		sheet.addMergedRegion(rangeAddress8);
		sheet.addMergedRegion(rangeAddress9);
		sheet.addMergedRegion(rangeAddress15);
		sheet.addMergedRegion(rangeAddress16);
		sheet.addMergedRegion(rangeAddress18);
		sheet.addMergedRegion(rangeAddress22);


		HSSFCellStyle headStyle = wb.createCellStyle();
		HSSFFont headFont = wb.createFont();
		headFont.setFontName("黑体");
		headFont.setFontHeightInPoints((short) 18);
		headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		headStyle.setFont(headFont);
		headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);


		HSSFCellStyle contentStyle = wb.createCellStyle();
		HSSFFont contentFont = wb.createFont();
		contentFont.setFontName("黑体");
		contentFont.setFontHeightInPoints((short) 12);
		contentStyle.setFont(contentFont);
		contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
		contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
		contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
		contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
		contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

		HSSFCellStyle titleStyle = wb.createCellStyle();
		HSSFFont titleFont = wb.createFont();
		titleFont.setFontName("黑体");
		titleFont.setFontHeightInPoints((short) 12);
		titleStyle.setFont(titleFont);

		HSSFRow sheetRow = sheet.createRow(0);
		HSSFCell cell = sheetRow.createCell(0);
		cell.setCellValue("天津市粮食储备有限公司市级储备稻谷轮换入库情况登统表");
		cell.setCellStyle(headStyle);
		HSSFRow sheetRow1 = sheet.createRow(1);
		HSSFCell cell1 = sheetRow1.createCell(0);
		HSSFCell cell2 = sheetRow1.createCell(6);
		HSSFCell cell3 = sheetRow1.createCell(13);
		cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
		cell1.setCellStyle(titleStyle);
		SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
		cell2.setCellValue("填报日期："+format.format(new Date()));
		cell2.setCellStyle(titleStyle);
		cell3.setCellValue("计量单位：吨（保留小数）");
		cell3.setCellStyle(titleStyle);
		//在表格的第一行设置与数据库列名对应的列的名称
		int rowNum = 2;
		HSSFRow row = sheet.createRow(rowNum);
		HSSFCell rowCell1 = row.createCell(0);
		rowCell1.setCellValue("序号");
		HSSFCell rowCell2 = row.createCell(1);
		rowCell2.setCellValue("车号");
		HSSFCell rowCell3 = row.createCell(2);
		rowCell3.setCellValue("仓号");
		HSSFCell rowCell4 = row.createCell(3);
		rowCell4.setCellValue("品名");
		HSSFCell rowCell5 = row.createCell(4);
		rowCell5.setCellValue("生产年度");
		HSSFCell rowCell6 = row.createCell(5);
		rowCell6.setCellValue("入库日期");
		HSSFCell rowCell7 = row.createCell(6);
		rowCell7.setCellValue("入库数量");
		HSSFCell rowCell8 = row.createCell(7);
		rowCell8.setCellValue("入库质量指标");
		HSSFCell rowCell9 = row.createCell(17);
		rowCell9.setCellValue("存储方式");
		HSSFCell rowCell10 = row.createCell(18);
		rowCell10.setCellValue("备注");
		HSSFCell rowCell11 = row.createCell(8);
		HSSFCell rowCell12 = row.createCell(9);
		HSSFCell rowCell13 = row.createCell(10);
		HSSFCell rowCell14 = row.createCell(11);
		HSSFCell rowCell15 = row.createCell(12);
		HSSFCell rowCell16 = row.createCell(13);
		HSSFCell rowCell17 = row.createCell(14);
		HSSFCell rowCell18 = row.createCell(15);
		HSSFCell rowCell19 = row.createCell(16);
		rowCell1.setCellStyle(contentStyle);
		rowCell2.setCellStyle(contentStyle);
		rowCell3.setCellStyle(contentStyle);
		rowCell4.setCellStyle(contentStyle);
		rowCell5.setCellStyle(contentStyle);
		rowCell6.setCellStyle(contentStyle);
		rowCell7.setCellStyle(contentStyle);
		rowCell8.setCellStyle(contentStyle);
		rowCell9.setCellStyle(contentStyle);
		rowCell10.setCellStyle(contentStyle);
		rowCell11.setCellStyle(contentStyle);
		rowCell12.setCellStyle(contentStyle);
		rowCell13.setCellStyle(contentStyle);
		rowCell14.setCellStyle(contentStyle);
		rowCell15.setCellStyle(contentStyle);
		rowCell16.setCellStyle(contentStyle);
		rowCell17.setCellStyle(contentStyle);
		rowCell18.setCellStyle(contentStyle);
		rowCell19.setCellStyle(contentStyle);


		rowNum+=1;
		HSSFRow row1 = sheet.createRow(rowNum);
		HSSFCell row1Cell1 = row1.createCell(7);
		HSSFCell row1Cell2 = row1.createCell(8);
		HSSFCell row1Cell3 = row1.createCell(9);
		HSSFCell row1Cell4 = row1.createCell(10);
		HSSFCell row1Cell5 = row1.createCell(11);
		HSSFCell row1Cell6 = row1.createCell(12);
		HSSFCell row1Cell7 = row1.createCell(13);
		HSSFCell row1Cell8 = row1.createCell(14);
		HSSFCell row1Cell9 = row1.createCell(15);
		HSSFCell row1Cell10 = row1.createCell(16);
		HSSFCell row1Cell11 = row1.createCell(0);
		HSSFCell row1Cell12 = row1.createCell(1);
		HSSFCell row1Cell13 = row1.createCell(2);
		HSSFCell row1Cell14 = row1.createCell(3);
		HSSFCell row1Cell15 = row1.createCell(4);
		HSSFCell row1Cell16 = row1.createCell(5);
		HSSFCell row1Cell17 = row1.createCell(6);
		HSSFCell row1Cell18 = row1.createCell(17);
		HSSFCell row1Cell19 = row1.createCell(18);
		row1Cell1.setCellValue("等级");
		row1Cell2.setCellValue("出糙率%");
		row1Cell3.setCellValue("整精米率%");
		row1Cell4.setCellValue("杂质%");
		row1Cell5.setCellValue("水分%");
		row1Cell6.setCellValue("黄粒米%");
		row1Cell7.setCellValue("谷外糙米%");
		row1Cell8.setCellValue("互混率%");
		row1Cell9.setCellValue("色泽气味%");
		row1Cell10.setCellValue("脂肪酸值KOH/干基 mg/100g");
		row1Cell1.setCellStyle(contentStyle);
		row1Cell2.setCellStyle(contentStyle);
		row1Cell3.setCellStyle(contentStyle);
		row1Cell4.setCellStyle(contentStyle);
		row1Cell5.setCellStyle(contentStyle);
		row1Cell6.setCellStyle(contentStyle);
		row1Cell7.setCellStyle(contentStyle);
		row1Cell8.setCellStyle(contentStyle);
		row1Cell9.setCellStyle(contentStyle);
		row1Cell10.setCellStyle(contentStyle);
		row1Cell11.setCellStyle(contentStyle);
		row1Cell12.setCellStyle(contentStyle);
		row1Cell13.setCellStyle(contentStyle);
		row1Cell14.setCellStyle(contentStyle);
		row1Cell15.setCellStyle(contentStyle);
		row1Cell16.setCellStyle(contentStyle);
		row1Cell17.setCellStyle(contentStyle);
		row1Cell18.setCellStyle(contentStyle);
		row1Cell19.setCellStyle(contentStyle);

		Integer xh=1;
		double rksl = 0d;
		for(int i=0; i<list.size();i++){
			HSSFRow hssfRow = sheet.createRow(++rowNum);
			HSSFCell hssfCell1 = hssfRow.createCell(0);
			HSSFCell hssfCell2 = hssfRow.createCell(1);
			HSSFCell hssfCell3 = hssfRow.createCell(2);
			HSSFCell hssfCell4 = hssfRow.createCell(3);
			HSSFCell hssfCell5 = hssfRow.createCell(4);
			HSSFCell hssfCell6 = hssfRow.createCell(5);
			HSSFCell hssfCell7 = hssfRow.createCell(6);
			HSSFCell hssfCell8 = hssfRow.createCell(7);
			HSSFCell hssfCell9 = hssfRow.createCell(8);
			HSSFCell hssfCell10 = hssfRow.createCell(9);
			HSSFCell hssfCell11 = hssfRow.createCell(10);
			HSSFCell hssfCell12 = hssfRow.createCell(11);
			HSSFCell hssfCell13 = hssfRow.createCell(12);
			HSSFCell hssfCell14 = hssfRow.createCell(13);
			HSSFCell hssfCell15 = hssfRow.createCell(14);
			HSSFCell hssfCell16 = hssfRow.createCell(15);
			HSSFCell hssfCell17 = hssfRow.createCell(16);
			HSSFCell hssfCell18 = hssfRow.createCell(17);
			HSSFCell hssfCell19 = hssfRow.createCell(18);
			hssfCell1.setCellValue(xh);
			hssfCell2.setCellValue((String)list.get(i).get("cphm"));
			hssfCell3.setCellValue((String)list.get(i).get("cf"));
			hssfCell4.setCellValue((String)list.get(i).get("lspz"));
			hssfCell5.setCellValue((String)list.get(i).get("scnf"));
			Date date = (Date)list.get(i).get("rq");
			hssfCell6.setCellValue(format.format(date));
			rksl = Double.parseDouble(list.get(i).get("rksl").toString());
			rksl = rksl/1000;
			String rksls = rksl+"";
			rksls = ParameterUtil.decimalFormat(3, rksls, true);
			hssfCell7.setCellValue(rksls);
			//hssfCell7.setCellValue(((BigDecimal)list.get(i).get("rksl")).toString());
			hssfCell8.setCellValue((String)list.get(i).get("lsdj"));
			hssfCell9.setCellValue((String)list.get(i).get("ccl"));
			hssfCell10.setCellValue((String)list.get(i).get("zjml"));
			hssfCell11.setCellValue((String)list.get(i).get("zzzl"));
			hssfCell12.setCellValue((String)list.get(i).get("sf"));
			hssfCell13.setCellValue((String)list.get(i).get("hlm"));
			hssfCell14.setCellValue((String)list.get(i).get("gwcm"));
			hssfCell15.setCellValue((String)list.get(i).get("hhl"));
			hssfCell16.setCellValue((String)list.get(i).get("szqw"));
			hssfCell18.setCellValue((String)list.get(i).get("ccfs"));
			hssfCell17.setCellValue((String)list.get(i).get("zfsz"));
			hssfCell1.setCellStyle(contentStyle);
			hssfCell2.setCellStyle(contentStyle);
			hssfCell3.setCellStyle(contentStyle);
			hssfCell4.setCellStyle(contentStyle);
			hssfCell5.setCellStyle(contentStyle);
			hssfCell6.setCellStyle(contentStyle);
			hssfCell7.setCellStyle(contentStyle);
			hssfCell8.setCellStyle(contentStyle);
			hssfCell9.setCellStyle(contentStyle);
			hssfCell10.setCellStyle(contentStyle);
			hssfCell11.setCellStyle(contentStyle);
			hssfCell12.setCellStyle(contentStyle);
			hssfCell13.setCellStyle(contentStyle);
			hssfCell14.setCellStyle(contentStyle);
			hssfCell15.setCellStyle(contentStyle);
			hssfCell16.setCellStyle(contentStyle);
			hssfCell17.setCellStyle(contentStyle);
			hssfCell18.setCellStyle(contentStyle);
			hssfCell19.setCellStyle(contentStyle);
			++xh;
		}
		HSSFRow hssfRow = sheet.createRow(rowNum+1);
		HSSFCell hssfCell1 = hssfRow.createCell(0);
		HSSFCell hssfCell2 = hssfRow.createCell(6);
		HSSFCell hssfCell3 = hssfRow.createCell(13);
		hssfCell1.setCellValue("单位负责人："+(dwfzr==null?"":dwfzr));
		hssfCell2.setCellValue("科长：");
		hssfCell3.setCellValue("制表人："+ (zbr==null?"":zbr));
		hssfCell1.setCellStyle(titleStyle);
		hssfCell2.setCellStyle(titleStyle);
		hssfCell3.setCellStyle(titleStyle);
		hssfRow.setRowStyle(titleStyle);
		CellRangeAddress rangeAddress19 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);
		CellRangeAddress rangeAddress20 = new CellRangeAddress(rowNum+1,rowNum+1,6,12);
		CellRangeAddress rangeAddress21 = new CellRangeAddress(rowNum+1,rowNum+1,13,18);
		sheet.addMergedRegion(rangeAddress19);
		sheet.addMergedRegion(rangeAddress20);
		sheet.addMergedRegion(rangeAddress21);
		return wb;
	}

}
