package com.chinaitop.agile.service.impl;


import java.util.List;

import javax.annotation.Resource;
import org.springframework.stereotype.Service;

import com.chinaitop.agile.mapper.DataCrkywTzdxxDefaultMapper;
import com.chinaitop.agile.mapper.DataCrkywTzdxxFlt001Mapper;
import com.chinaitop.agile.model.DataCrkywTzdxxDefault;
import com.chinaitop.agile.model.DataCrkywTzdxxDefaultExample;
import com.chinaitop.agile.model.DataCrkywTzdxxFlt001;
import com.chinaitop.agile.model.DataCrkywTzdxxFlt001Example;
import com.chinaitop.agile.model.DataCrkywTzdxxFlt001Example.Criteria;
import com.chinaitop.agile.service.TzdxxService;


@Service
public class TzdxxServiceImpl implements TzdxxService{
	@Resource
	private DataCrkywTzdxxDefaultMapper dataCrkywTzdxxDefaultMapper;
	@Resource
	private DataCrkywTzdxxFlt001Mapper dataCrkywTzdxxFlt001Mapper;


	@Override
	public List<DataCrkywTzdxxFlt001> queryByExample(Integer tzdId,Integer htId,Integer orgId,Integer houseId,Integer warehouseId) {
		// TODO Auto-generated method stub
		DataCrkywTzdxxDefaultExample exampleTzd = new DataCrkywTzdxxDefaultExample();
		com.chinaitop.agile.model.DataCrkywTzdxxDefaultExample.Criteria createCriteriaTzd = exampleTzd.createCriteria();
		createCriteriaTzd.andUnitidEqualTo(orgId.toString());

		if(tzdId!=null){
			createCriteriaTzd.andTzdidEqualTo(tzdId);
		}
		if(htId!=null){
			createCriteriaTzd.andHtidEqualTo(htId);
		}
		List<DataCrkywTzdxxDefault> list = dataCrkywTzdxxDefaultMapper.selectByExample(exampleTzd);

		List<DataCrkywTzdxxFlt001> mxList = null;
		if(list.size()>0){
			//根据主表信息 查询对应的子表数据 
			DataCrkywTzdxxFlt001Example exampleTzdmx = new DataCrkywTzdxxFlt001Example();
			Criteria createCriteriaTzdmx = exampleTzdmx.createCriteria();
			for (DataCrkywTzdxxDefault dataCrkywTzdxxDefault : list) {
				//主表dataid. 对应 从表maindataid
				createCriteriaTzdmx.andUnitidEqualTo(orgId.toString());
				createCriteriaTzdmx.andMaindataidEqualTo(dataCrkywTzdxxDefault.getDataid());
				createCriteriaTzdmx.andChidEqualTo(houseId.toString());
				if(warehouseId!=null){
					createCriteriaTzdmx.andHwidEqualTo(warehouseId.toString());
				}
				mxList = dataCrkywTzdxxFlt001Mapper.selectByExample(exampleTzdmx);
			}
		}
		return mxList;
		
	}

	
}
